"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var govern_1 = require("govern");
var Subscribe_1 = require("./Subscribe");
/**
 * A Higher Order Component version of the <Subscribe to /> component.
 */
function subscribe(mapOwnPropsToElement, mapValueToProps, mapDispatchToProps, merge) {
    if (mapValueToProps === void 0) { mapValueToProps = function (value, dispatch, ownProps) { return value; }; }
    if (mapDispatchToProps === void 0) { mapDispatchToProps = function (dispatch, initialValue) { return ({ dispatch: dispatch }); }; }
    if (merge === void 0) { merge = function (valueProps, dispatchProps, ownProps) { return Object.assign({}, valueProps, dispatchProps, ownProps); }; }
    var mapFn = mapOwnPropsToElement;
    if (govern_1.isValidElement(mapOwnPropsToElement) || govern_1.isValidStore(mapOwnPropsToElement)) {
        mapFn = (function () { return mapOwnPropsToElement; });
    }
    else if (mapOwnPropsToElement instanceof govern_1.Component.constructor) {
        mapFn = function (props) { return govern_1.createElement(mapOwnPropsToElement, props); };
    }
    if (typeof mapFn !== 'function') {
        throw new Error("\"govern(..., mapFn)\" received an unknown \"mapFn\" of type \"" + typeof mapFn + "\" for \"" + String(mapOwnPropsToElement) + "\".");
    }
    var decorator = function (WrappedComponent) {
        // Use a class component instead of a stateless functional component so
        // that consumers can use refs if they need.
        return /** @class */ (function (_super) {
            __extends(SubscribeWrapper, _super);
            function SubscribeWrapper() {
                return _super !== null && _super.apply(this, arguments) || this;
            }
            SubscribeWrapper.prototype.render = function () {
                var _this = this;
                return Subscribe_1.createSubscribe(mapFn(this.props), function (value, dispatch) {
                    var valueProps = mapValueToProps(value, dispatch, _this.props);
                    if (!_this.dispatchProps) {
                        _this.dispatchProps = mapDispatchToProps(dispatch, value);
                    }
                    return React.createElement(WrappedComponent, merge(valueProps, _this.dispatchProps, _this.props));
                });
            };
            SubscribeWrapper.prototype.componentWillUnmount = function () {
                delete this.dispatchProps;
            };
            return SubscribeWrapper;
        }(React.Component));
    };
    return decorator;
}
exports.subscribe = subscribe;
//# sourceMappingURL=subscribeHOC.js.map